---
##
# retrieve and configure kolla
#
- hosts: jumphost
  any_errors_fatal: true
  vars_files:
    - "vars/idf.yml"
    - "vars/pdf.yml"
  tasks:
    - name: ensure relevant pip packages are installed
      pip:
        name: "{{ python_packages }}"
        state: present
      become: true

    ##
    # Get public auth url
    ##
    - name: get public auth_url
      shell: |
        openstack --os-cloud {{ cloud_admin }} endpoint list -f yaml
      args:
        executable: /bin/bash
      register: endpoints
      tags:
        - skip_ansible_lint

    - name: get public os_auth_url
      set_fact:
        os_user_auth_url: >-
          {{ endpoints.stdout | from_yaml |
              selectattr('Interface', 'equalto', openstack_user_interface) |
              selectattr('Service Name', 'equalto', 'keystone')|
              map(attribute='URL') | list |first }}

    ##
    # Set user
    ##

    - name: retrieve user password
      set_fact:
        openstack_user_password:
          "{{ lookup('env','USER_PASSWORD')
              | default(os_infra.user.password, true)
              | default(lookup('password',
                        '/dev/null length=32 chars=ascii_letters,digits')) }}"

    - name: create the user
      os_user:
        cloud: "{{ cloud_admin }}"
        state: present
        name: "{{ openstack_user_name }}"
        password: "{{ openstack_user_password }}"
        update_password: always
        domain: "{{ os_user_domain_name }}"

    - name: save local openstack_user_openrc
      copy:
        content: |
          export OS_PROJECT_DOMAIN_NAME={{ os_project_domain_name }}
          export OS_USER_DOMAIN_NAME={{ os_user_domain_name }}
          export OS_PROJECT_NAME={{ openstack_tenant_name }}
          export OS_TENANT_NAME={{ openstack_tenant_name }}
          export OS_USERNAME={{ openstack_user_name }}
          export OS_PASSWORD={{ openstack_user_password }}
          export OS_AUTH_URL={{ os_user_auth_url }}
          export OS_INTERFACE={{ openstack_user_interface }}
          export OS_IDENTITY_API_VERSION={{ os_identity_api_version }}
          export OS_REGION_NAME={{ os_region_name }}
          export OS_AUTH_PLUGIN=password
        dest: "{{ playbook_dir }}/vars/openstack_user_openrc"
      delegate_to: "127.0.0.1"
